
Redmine - Feature #4796

Rails 3 support

2010-02-10 23:01 - Eric Davis

Status: Closed Start date: 2010-02-10

Priority: Low Due date:  

Assignee: Jean-Philippe Lang % Done: 100%

Category: Rails support Estimated time: 0.00 hour

Target version: 2.0.0   

Resolution: Fixed   

Description

Migrate Redmine to Rails 3 once Rails is out of beta.  Must make sure Redmine plugins are still functional and can be ported easily

from Rails 2.x.

http://guides.rails.info/3_0_release_notes.html

http://twitter.com/bitsweat/statuses/5626354036

Related issues:

Related to Redmine - Defect #8421: REST API may produce invalid json Closed 2011-05-21

Related to Redmine - Feature #4005: Setup shoulda to make it easier to test Closed 2009-10-08

Related to Redmine - Defect #8989: r6351 causes unexpected chars to be displa... Closed 2011-08-05

Related to Redmine - Defect #8751: Email notification: bug, when number of re... Closed 2011-07-06

Related to Redmine - Patch #6317: Template names conventions Closed 2010-09-07

Related to Redmine - Defect #9252: Regression: application title escaped 2 times Closed 2011-09-15

Related to Redmine - Feature #9759: HTML minification and compression New

Associated revisions

Revision 6412 - 2011-08-06 02:49 - Toshi MARUYAMA

replace « and » at app/helpers/application_helper.rb to hexadecimal UTF-8 strings (#4796).

Revision 6413 - 2011-08-06 02:50 - Toshi MARUYAMA

replace « and » at app/views/search/index.rhtml to hexadecimal UTF-8 strings (#4796).

Revision 6414 - 2011-08-06 02:50 - Toshi MARUYAMA

replace « and » at app/views/wiki/show.rhtml to hexadecimal UTF-8 strings (#4796).

Revision 6491 - 2011-08-20 15:40 - Toshi MARUYAMA

replace « and » at app/views/gantts/show.html.erb to hexadecimal UTF-8 strings (#4796).

Revision 6515 - 2011-08-21 07:17 - Toshi MARUYAMA

replace « and » at app/views/activities/index.html.erb to hexadecimal UTF-8 strings (#4796).

Revision 7246 - 2011-09-16 03:50 - Toshi MARUYAMA

backed out r6350 (#9252, #4796)

HTML escape at app/helpers/application_helper.rb

Revision 7591 - 2011-10-07 02:23 - Toshi MARUYAMA

Rails3: model: query: parse dates using UTC (ruby 1.9 inside) (#4796)

On Rails 3.0 and Ruby 1.8.7 in Japan (UTC+9), tests fails with following messages.

test_operator_date_equals(QueryTest) [test/unit/query_test.rb:206]:

<"(issues.due_date > '2011-07-09 14:59:59.999999' AND issues.due_date <= '2011-07-10 14:59:59.999999')

AND (issue_statuses.is_closed='f')"> expected to be =~

</issues\.due_date > '2011-07-09 23:59:59(\.9+)?' AND issues\.due_date <= '2011-07-10 23:59:59(\.9+)?/>.
Contributed by Sylvain Utard.

Revision 8304 - 2011-12-20 09:32 - Toshi MARUYAMA

Rails3: rename sample_plugin .rhtml to .html.erb (#6317, #4796)

:rhtml and :rxml were finally removed as template handlers at Rails 3.1 RC4.

Revision 8702 - 2012-01-26 06:15 - Toshi MARUYAMA

Rails3.2: pdf: comment out ::ActionView::TemplateHandlers::ERB of rfpdf plugin (#4796)

ActionView::TemplateHandlers is deprecated on Rails3.2

and Redmine cannot boot on Rails3.2.

Redmine does not use this rfpdf plugin feature.

Revision 8713 - 2012-01-28 05:57 - Toshi MARUYAMA

Ruby1.9: set Encoding.default_external on only Rails2 (#4050, #4796)

Revision 8714 - 2012-01-28 05:58 - Toshi MARUYAMA

Ruby1.9: enforce UTF-8 encodings on the params hash on Rails2 (#4050, #4796)

Without this change, non ASCII subject issue cannot be created on Ruby 1.9.

Revision 8716 - 2012-01-28 11:26 - Toshi MARUYAMA

Ruby1.9: skip enforcing UTF-8 encodings on the params hash on Rails2 if it is frozen (#4050, #4796)

Tests on CI server fail.

http://www.redmine.org/builds/build_trunk-1.9.2-sqlite3_257.html

  1) Error:

test_index_with_short_filters(IssuesControllerTest):

RuntimeError: can't modify frozen string

    /var/lib/hudson/jobs/trunk-1.9.2-sqlite3/workspace/app/controllers/application_controller.rb:58:in `force_

encoding'

    /var/lib/hudson/jobs/trunk-1.9.2-sqlite3/workspace/app/controllers/application_controller.rb:58:in `utf8ni

ze!'

    /var/lib/hudson/jobs/trunk-1.9.2-sqlite3/workspace/app/controllers/application_controller.rb:60:in `block 

in utf8nize!'

    /var/lib/hudson/jobs/trunk-1.9.2-sqlite3/workspace/app/controllers/application_controller.rb:60:in `each'

    /var/lib/hudson/jobs/trunk-1.9.2-sqlite3/workspace/app/controllers/application_controller.rb:60:in `utf8ni

ze!'

    /var/lib/hudson/jobs/trunk-1.9.2-sqlite3/workspace/app/controllers/application_controller.rb:52:in `params

_filter'

    /var/lib/hudson/ruby1.9.2/lib/ruby/gems/1.9.1/gems/activesupport-2.3.14/lib/active_support/callbacks.rb:17

8:in `evaluate_method'

    /var/lib/hudson/ruby1.9.2/lib/ruby/gems/1.9.1/gems/activesupport-2.3.14/lib/active_support/callbacks.rb:16

6:in `call'

    /var/lib/hudson/ruby1.9.2/lib/ruby/gems/1.9.1/gems/actionpack-2.3.14/lib/action_controller/filters.rb:225:

in `call'

    /var/lib/hudson/ruby1.9.2/lib/ruby/gems/1.9.1/gems/actionpack-2.3.14/lib/action_controller/filters.rb:629:

in `run_before_filters'

    /var/lib/hudson/ruby1.9.2/lib/ruby/gems/1.9.1/gems/actionpack-2.3.14/lib/action_controller/filters.rb:615:

in `call_filters'

    /var/lib/hudson/ruby1.9.2/lib/ruby/gems/1.9.1/gems/actionpack-2.3.14/lib/action_controller/filters.rb:610:

in `perform_action_with_filters'

    /var/lib/hudson/ruby1.9.2/lib/ruby/gems/1.9.1/gems/actionpack-2.3.14/lib/action_controller/benchmarking.rb

:68:in `block in perform_action_with_benchmark'

    /var/lib/hudson/ruby1.9.2/lib/ruby/gems/1.9.1/gems/activesupport-2.3.14/lib/active_support/core_ext/benchm

ark.rb:17:in `block in ms'

Revision 8742 - 2012-01-31 03:41 - Toshi MARUYAMA

Rails3: add number.format to ro and sk locales (#4796)

Test fails on Rails 3.0.11 and Ruby 1.8.7.

Failure:

test_number_to_human_size_for_each_language(Redmine::I18nTest)

    [test/unit/lib/redmine/i18n_test.rb:114:in `test_number_to_human_size_for_each_language'

     test/unit/lib/redmine/i18n_test.rb:112:in `each'

     test/unit/lib/redmine/i18n_test.rb:112:in `test_number_to_human_size_for_each_language']:

2024-03-13 2/14

http://www.redmine.org/builds/build_trunk-1.9.2-sqlite3_257.html


sk failure.

Exception raised:

TypeError(<can't convert nil into String>)

Revision 8833 - 2012-02-10 14:08 - Toshi MARUYAMA

Ruby1.9: move setting Encoding.default_external after boot (#4050, #4796)

"ruby test/functional/repositories_git_controller_test.rb" fails

on Japanese Windows and Mingw Ruby 1.9.3p0

because "Rails" is not defined.

History

#1 - 2010-08-31 14:40 - Etienne Massip

Rails 3 final is out (http://weblog.rubyonrails.org/2010/8/29/rails-3-0-it-s-done) !

Someone already did the job : http://github.com/jeremy/redmine !

#2 - 2010-10-25 17:00 - Eric Davis

- Assignee deleted (Eric Davis)

#3 - 2010-11-25 14:19 - Luiz Picanço

Any news about this ?

#4 - 2010-12-05 16:57 - John Yani

1.2.0 will stick with 2.3.10 (#6887)

Maybe after 1.2.0 release something will be clearer. What is engines support BTW?

#5 - 2010-12-06 12:30 - Eric Thomas

John Yani wrote:

1.2.0 will stick with 2.3.10 (#6887)

Maybe after 1.2.0 release something will be clearer. What is engines support BTW?

 The next release of rails (3.1) will have engines support.

#6 - 2010-12-06 12:32 - Felix Schäfer

Eric Thomas wrote:

The next release of rails (3.1) will have engines support.

 Source/link? I fear they won't work exactly like the ones in 2.3 did, i.e. we still have to evaluate exactly what changes and how that affects us.

#7 - 2010-12-06 12:53 - Jean-Baptiste Barth

Sources: rails-engines site,  the blog of Piotr Sarnacki, and I've got some bookmarks about the transition at home.

What's sure for now:

Rails 3.0 supports a kind of Engines, but there's no mechanism for migrations, nor copying assets automatically (nor overriding views iirc) ; for

sure they're not useable in Redmine at this point

Rails 3.1 Engines will support these kind of things (needs to be precised I know), but all documentation I read on Rails3' engines makes me think

that plugin developers would have to package their plugin as a gem

Redmine cannot support Rails 2.3.x and Rails 3.x at the same time :)

#8 - 2011-02-16 10:11 - Etienne Massip

Just a note about .xml format : Rails 3 does not include Builder anymore, it's now one of its dependencies.

#9 - 2011-03-23 08:58 - Toshi MARUYAMA

- Category set to Rails support

#10 - 2011-05-24 17:03 - Etienne Massip
Jean-Baptiste Barth wrote:

Rails 3.0 supports a kind of Engines, but there's no mechanism for migrations, nor copying assets automatically (nor overriding views iirc) ;

for sure they're not useable in Redmine at this point

Rails 3.1 Engines will support these kind of things (needs to be precised I know), but all documentation I read on Rails3' engines makes me

think that plugin developers would have to package their plugin as a gem

 Indeed, Rails 3.1 RC is out and supports migrations as well as moutable apps, see http://weblog.rubyonrails.org/2011/5/22/rails-3-1-release-candidate

.

Notes- :

Rails 3 applications include a Gemfile and support the use of Bundler (see http://weblog.rubyonrails.org/2010/8/29/rails-3-0-it-s-done).

Rails 3.1 default scripting lib is now jQuery instead of Prototype.

#11 - 2011-06-14 16:00 - Fabian Becker

Is there any update on migrating to Rails 3.x? It's becoming a pain maintaining Redmine as it currently is. Upgrading to 3.0/3.1RC would definitely

improve the development process.

I do understand that you are having trouble loosing compatibility to lots of good Redmine plugins, so I suggest you start Redmine + Rails 3.1RC

development on a seperate branch and publish Redmine for both Rails versions in a transitional period (maybe 1 year?) giving all plugin developers

time to migrate their plugins to a Rails Engine.

Any thoughts?

#12 - 2011-06-14 16:13 - Etienne Massip

- Target version set to Candidate for next major release

Fabian Becker wrote:

It's becoming a pain maintaining Redmine as it currently is.

 Can't see why ?

#13 - 2011-06-20 13:01 - Toshi MARUYAMA

I merged trunk r6097 and following forks.

https://github.com/goncalossilva/redmine

https://github.com/marutosi/redmine/tree/rails3-merged

https://github.com/marutosi/redmine/commit/13077ffdba5150e95a2a0d70eb6135ead8ed254c

I rearranged revisions.

https://bitbucket.org/marutosi/redmine-rails3-bb-straight-20110620

https://bitbucket.org/marutosi/redmine-rails3-bb-straight-20110620/changeset/b1cc0367a6b0

https://github.com/marutosi/redmine/commits/rails3-straight-20110620

https://github.com/marutosi/redmine/commit/b91eafdb008b0f0b3ff6ab830c9d07cfe393c341

#14 - 2011-06-22 12:20 - Toshi MARUYAMA

I updated revisions.

Merged

https://github.com/marutosi/redmine/tree/rails3-merged

https://github.com/marutosi/redmine/commit/3e126b55cf6895fc923fbf2e3aeadda2d1d54dfa

Straight revisions

https://github.com/marutosi/redmine/commits/rails3-straight-20110622

https://github.com/marutosi/redmine/commit/58374b477dd99b7df905b6fdb881aaf45185acf2

https://bitbucket.org/marutosi/redmine-rails3-bb-straight-20110622

https://bitbucket.org/marutosi/redmine-rails3-bb-straight-20110622/changeset/caeaaabe8709

#15 - 2011-06-22 20:08 - Etienne Massip

You should try to make it work straight with Rails 3.1 (rc4 is the last release) since (I guess) Redmine will never run with 3.0 due to the lack of engine

support.
Moreover, you might detect and report some Rails 3.1 rc issues whic could be fixed before release time, making it easier to integrate with RM.

BTW, do you run Rails 3 RM with Ruby 1.9 ?

#16 - 2011-06-27 00:53 - Toshi MARUYAMA

I start to target Rails 3.1.

Merged

https://github.com/marutosi/redmine/tree/rails3.1-merged

https://github.com/marutosi/redmine/commit/d8b96c046d342b82273aa0d63a36fea91b3ed200

Straight revisions

https://bitbucket.org/marutosi/redmine-rails3.1-bb

https://bitbucket.org/marutosi/redmine-rails3.1-bb/changeset/fb582ad0e5e3

https://github.com/marutosi/redmine/tree/rails3.1-20110625

https://github.com/marutosi/redmine/commit/443313972d57f378197585498690c5f5f22cd4c6

The biggest issue is that ActionDispatch::Routing::Routes at config/routes.rb removed on Rails 3.1.

https://bitbucket.org/marutosi/redmine-rails3.1-bb/changeset/e8800779ffb0

https://github.com/marutosi/redmine/commit/e864d6dc582ac42aa1ef5d25b7c7810653466ff8

With dummy config/routes.rb, this revisions can boot with "ruby script/rails server",

and run "rake test:units".

#17 - 2011-07-19 11:14 - Etienne Massip

RoR team is organizing a hack fest for 3.1 : http://weblog.rubyonrails.org/2011/7/14/rails-3-1-hackfest

#18 - 2011-08-22 08:34 - Toshi MARUYAMA

I rebased on r6523.

Git:

https://github.com/marutosi/redmine/commits/rails3.1-straight-20110822

https://github.com/marutosi/redmine/commit/5f46bcc5ad70db3907a81312c42bff09b93b305d

Mercurial:

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20110822-hg-git

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20110822-hg-git/changeset/1d5fca5d898e

#19 - 2011-08-23 01:32 - Toshi MARUYAMA

I success to show main menu on Rails 3.1.

Git:

https://github.com/marutosi/redmine/commits/rails3.1-straight-20110822

https://github.com/marutosi/redmine/commit/f203473b56b14e2e2d2cbca359e1345389c8b2b5

Mercurial:

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20110822-hg-git

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20110822-hg-git/changeset/d68bc29b957b

#20 - 2011-08-23 07:32 - Toshi MARUYAMA

http://mrjaba.posterous.com/ruby-news-roundup-06-04-2011

:rhtml and :rxml were finally removed as template handlers.

#21 - 2011-08-23 17:10 - Etienne Massip

Nice job on routes =)

Got some nice reading for you: http://www.h-online.com/open/features/From-Rails-2-3-to-3-0-1285884.html

Edit: permalink: http://h-online.com/-1285884
#22 - 2011-08-23 18:03 - Luiz Picanço

Interesting article !

Etienne Massip wrote:

Nice job on routes =)

Got some nice reading for you: http://www.h-online.com/open/features/From-Rails-2-3-to-3-0-1285884.html

Edit: permalink: http://h-online.com/-1285884

#23 - 2011-08-25 10:52 - David Bennett

If you need any direction, the Spree project has great 3.0 and 3.1 support: http://spreecommerce.com/blog

The "Extension" system they have is great as you just add a line in your Gemfile that points to a github project and vola! extra features :)

BDQ has also created Deface, A view editor that alters views based on css rules: https://github.com/railsdog/deface

#24 - 2011-08-31 09:08 - Etienne Massip

3.1 released 3 hours ago: http://twitter.com/#!/rails/status/108740744306634752

Release notes: http://guides.rubyonrails.org/3_1_release_notes.html

#25 - 2011-08-31 16:19 - Etienne Massip

Another article from the H: http://h-online.com/-1285887

#26 - 2011-09-09 05:33 - Alexandre de Oliveira

So, is there any official announcement regarding 3.x support? A plan? Redmine 2.0? I found nothing on Wiki. Is there anyone leading the efforts to

this end?

Because I'd like to contribute to make Redmine Rails 3.x compatible. It's not clear if there's a branch for it. I guess any patch regarding this shouldn't

go to master branch, isn't it? It seems Toshi is already doing some work on this. How could I be of help regarding this matter?

Second, don't you agree this is not the correct place for posting about these Rails 3.1's new features articles, like Etienne's?

Thank you.

#27 - 2011-10-16 06:48 - Toshi MARUYAMA

- % Done changed from 0 to 40

I rebased on r7627.

Git:

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111015-git

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111015-git/changeset/b518355cf567

https://github.com/marutosi/redmine/tree/rails3.1-straight-20111015

https://github.com/marutosi/redmine/commit/b518355cf567a6aea40f463a879c752a308c1e32

Mercurial:

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111015-hg-git

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111015-hg-git/changeset/230bb3836ed1

If you run with current database of Redmine 1.2 on Rails 2.3.11,

you need to run "rake db:migrate".

In order to run tests,

you need to install object_daddy for Rails 3.1.

ruby script/rails plugin install git://github.com/awebneck/object_daddy.git

The revisions are from following repositories.

https://github.com/redox/redmine
https://github.com/mhanne/chiliproject/tree/rails-3.1

https://github.com/thegcat/chiliproject/tree/rails-3.1

Git and Mercurial revisions are synchronized by hg-git .

If you want to improve it, you can choose what you like.

#28 - 2011-11-11 03:18 - David Bennett

As this is now Rails 3.1... and a lot of things will break in the upgrade anyway.

Would it be a good idea to change this to a mountable engine?

(or even a stranded engine so that users can upgrade by just changing the version in the Gemfile.)

I have experience and can help out if you go down this path.

CON: You may want to namespace everything so it plays nice with other mountable engines.

#29 - 2011-11-11 06:46 - Felix Schäfer

David, do you have experience with the 3.1 full engines?

#30 - 2011-11-14 03:47 - David Bennett

Felix Schäfer wrote:

David, do you have experience with the 3.1 full engines?

 If by full engines you mean ones with there own logic/models/controllers/migrations that can be added by just adding something to your Gemfile.

Then yes, I use them where ever possible :)

Though I don't have all that much experience with mountable ones yet.. as 3.1 is still new and I don't really have any bread-n-butter projects in my day

job that could use the functionality.

#31 - 2011-11-14 07:26 - Felix Schäfer

David Bennett wrote:

Felix Schäfer wrote:

David, do you have experience with the 3.1 full engines?

 If by full engines you mean ones with there own logic/models/controllers/migrations that can be added by just adding something to your Gemfile.

Then yes, I use them where ever possible :)

Though I don't have all that much experience with mountable ones yet.. as 3.1 is still new and I don't really have any bread-n-butter projects in

my day job that could use the functionality.

 No, that's full engines vs. mountable apps. Mountable apps are self-contained and referenced only in the parent routes.rb to tell which "top-level" URI

the mountable app has. Full engines are "nearer" to the 2.3 engines in that they are loaded with the main app, have access to all the same models,

controllers, and everything (mountable apps are fully segregated). Both types are/can be packaged as gems though.

#32 - 2011-11-28 06:00 - Toshi MARUYAMA

I rebased on r7962.

Git:

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111128-git

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111128-git/changeset/25af42e581e9

https://github.com/marutosi/redmine/tree/rails3.1-straight-20111128

https://github.com/marutosi/redmine/commit/25af42e581e9eb1b83253130e661edcfc50cd810

Mercurial:

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111128-hg-git

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111128-hg-git/changeset/e3236691b1c5

Revisions are from a following repository.
https://github.com/paneidos/redmine

#33 - 2011-11-28 16:28 - Toshi MARUYAMA

I rebased on r7967.

Git:

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111129-git

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111129-git/changeset/98b79bc74907

https://github.com/marutosi/redmine/tree/rails3.1-straight-20111129

https://github.com/marutosi/redmine/commit/98b79bc74907735b148d45e5e9ccb17a31656f10

Mercurial:

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111129-hg-git

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111129-hg-git/changeset/70aa2e5132cc

I adapted r7900 labelled_tabular_form_for.

#34 - 2011-12-05 11:06 - Toshi MARUYAMA

- % Done changed from 40 to 50

I rebased on r8089.

Git:

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111205-git

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111205-git/changeset/f63cfecfc970

https://github.com/marutosi/redmine/tree/rails3.1-straight-20111205

https://github.com/marutosi/redmine/commit/f63cfecfc9708cfd3f838b8444071da3d50a1e10

Mercurial:

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111205-hg-git

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111205-hg-git/changeset/adeada76a040

Changes

rename css to css.erb

use asset_path instead of hard-coded path

diff --git a/app/assets/stylesheets/scm.css.erb b/app/assets/stylesheets/scm.css.erb

--- a/app/assets/stylesheets/scm.css.erb

+++ b/app/assets/stylesheets/scm.css.erb

@@ -9,7 +9,7 @@

 li.change {

     list-style-type:none;

-    background-image: url(../images/bullet_black.png);

+    background-image: url(<%= asset_path "bullet_black.png" %>); 

     background-position: 1px 1px;

     background-repeat: no-repeat;

     padding-top: 1px;

Revisions are from following repository.

https://github.com/escline/redmine

#35 - 2011-12-21 01:22 - Toshi MARUYAMA

I rebased on r8304.

Git:

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111220-git

Rails 3.1.3

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111220-git/changeset/10734937ddd8

Rails 3.2.0.rc1

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111220-git/changeset/c62200edd4d7
https://github.com/marutosi/redmine/tree/rails3.1-straight-20111220

Rails 3.1.3

https://github.com/marutosi/redmine/commit/10734937ddd8

Rails 3.2.0.rc1

https://github.com/marutosi/redmine/commit/c62200edd4d7639da893a4c3d5ea6b987daf5b98

Mercurial:

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111220-hg-git

Rails 3.1.3

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111220-hg-git/changeset/97f974aea9ea

Rails 3.2.0.rc1

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20111220-hg-git/changeset/af9fdd89cd7d

#36 - 2012-01-03 10:01 - Toshi MARUYAMA

- % Done changed from 50 to 60

I rebased on r8480.

Almost all routing tests pass.

Git:

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20120103-git

Rails 3.1.3

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20120103-git/changeset/c44c5c55c9d2

Rails 3.2.0.rc1

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20120103-git/changeset/90bda5801f9d

https://github.com/marutosi/redmine/tree/rails3.1-straight-20120103

Rails 3.1.3

https://github.com/marutosi/redmine/commit/c44c5c55c9d2

Rails 3.2.0.rc1

https://github.com/marutosi/redmine/commit/90bda5801f9d

Mercurial:

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20120103-hg-git

Rails 3.1.3

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20120103-hg-git/changeset/a940b29a8193

Rails 3.2.0.rc1

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20120103-hg-git/changeset/d4fc04c4ef05

#37 - 2012-01-12 09:29 - Toshi MARUYAMA

- % Done changed from 60 to 70

I rebased on r8633.

route.rb is all new Rails3 format.

Git:

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20120111-git

Rails 3.1.3

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20120111-git/changeset/9b87ac4f7d4a

Rails 3.2.0.rc2

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20120111-git/changeset/8ef3aa076ac3

https://github.com/marutosi/redmine/tree/rails3.1-straight-20120111

Rails 3.1.3

https://github.com/marutosi/redmine/commit/9b87ac4f7d4a

Rails 3.2.0.rc2

https://github.com/marutosi/redmine/commit/8ef3aa076ac3

Mercurial:

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20120111-hg-git
Rails 3.1.3

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20120111-hg-git/changeset/38da0d316f07

Rails 3.2.0.rc2

https://bitbucket.org/marutosi/redmine-rails3.1-straight-20120111-hg-git/changeset/827d62056e93

#38 - 2012-01-24 19:50 - John Yani

Rails 3.2.0 is out

Is there any work break down structure of work required to complete porting Redmine to Rails 3? Are there any routine tasks that unexperienced

programmer could help with?

#39 - 2012-02-13 11:41 - Toshi MARUYAMA

I rebased on r8864.

Changes:

update Rails 3.2.1.

rails-dev-tweaks supports Rails 3.2.

Git:

https://bitbucket.org/marutosi/redmine-rails3-straight-20120213-git

Rails 3.1.3

https://bitbucket.org/marutosi/redmine-rails3-straight-20120213-git/changeset/b024f722f1e7

Rails 3.2.1

https://bitbucket.org/marutosi/redmine-rails3-straight-20120213-git/changeset/9ff1ec404049

https://github.com/marutosi/redmine/commits/rails3-straight-20120213

Rails 3.1.3

https://github.com/marutosi/redmine/commit/b024f722f1e7

Rails 3.2.1

https://github.com/marutosi/redmine/commit/9ff1ec404049

Mercurial:

https://bitbucket.org/marutosi/redmine-rails3-straight-20120213-hg-git

Rails 3.1.3

https://bitbucket.org/marutosi/redmine-rails3-straight-20120213-hg-git/changeset/761b7f104d6d

Rails 3.2.1

https://bitbucket.org/marutosi/redmine-rails3-straight-20120213-hg-git/changeset/b57dc3557b3c

#40 - 2012-02-29 13:19 - Sridhar P

I would like to work on this. I am thinking in the lines of forking on github and submitting pull requests whenever I have completed a significant task.

Talking of tasks, is there any list of issues/to-do's that I can work on?

#41 - 2012-03-02 20:18 - John Yani

Sridhar P wrote:

I would like to work on this. I am thinking in the lines of forking on github and submitting pull requests whenever I have completed a significant

task. Talking of tasks, is there any list of issues/to-do's that I can work on?

 I think you can start with cloning and setting up test environment to see what doesn't work. Then if you manually tested all features and everything

seems to work, you can run redmine tests and see if there are any failures. I there are no any, you're done.

Then you can think of how to enable users to use Redmine with both Rails 2 and Rails 3. As of now the work is done/coordinated by Toshi. Seems

like every week he rebases his work on the latest revision from svn trunk. AFAIK, there are no any todo lists. But you can look into git/hg log. There

are many commits marked as "TODO", so you can review these patches to see what's wrong with them.

#42 - 2012-03-02 20:39 - Jean-Philippe Lang

I have a working copy that runs and passes the full tests suite with Rails 3.1. There's some work to be done in order to provide the current features for

Redmine plugins (migrations, view overriding, assets...) but still, most plugins won't be compatible out of the box. And honestly, I'm a bit disappointed

with the performance. Redmine is 1.5x to 2x slower than with Rails 2.3. With ruby 1.9.3, it barely runs as fast as current trunk with Rails 2.3 + ruby

1.8.7.

Then you can think of how to enable users to use Redmine with both Rails 2 and Rails 3.
 That's not really an option. There are too many changes in Rails 3 to support both versions with the same code base.

#43 - 2012-03-02 20:46 - Jean-Philippe Lang

- File response_time.png added

Here are the results of my quick performance tests (Rails 2.3 vs. Rails 3.2):

 

#44 - 2012-03-02 22:19 - Toshi MARUYAMA

Jean-Philippe Lang wrote:

I have a working copy that runs and passes the full tests suite with Rails 3.1.

 Could you create branch and commit to it such as source:sandbox/rails-2.3 ?

#45 - 2012-03-07 02:43 - John Yani

Did anybody find out how to get wiki working? I've got an error:

can't write unknown attribute `versioned_type'

activerecord (3.2.1) lib/active_record/attribute_methods/write.rb:34:in `write_attribute'

activerecord (3.2.1) lib/active_record/attribute_methods/dirty.rb:67:in `write_attribute'

activerecord (3.2.1) lib/active_record/attribute_methods.rb:31:in `[]='

vendor/plugins/acts_as_versioned/lib/acts_as_versioned.rb:383:in `clone_versioned_model'

vendor/plugins/acts_as_versioned/lib/acts_as_versioned.rb:303:in `save_version_on_create'

app/controllers/wiki_controller.rb:154:in `update'

the problem is in the following line:

vendor/plugins/acts_as_versioned/lib/acts_as_versioned.rb

194:  self.versioned_inheritance_column = options[:inheritance_column] || "versioned_#{inheritance_column}"

Somehow versioned_type column is missing.

#46 - 2012-03-07 14:29 - John Yani

Update:

Seems like it is because Redmine doesn't use rake tasks provided by acts_as_versioned: create_versioned_table and  drop_versioned_table

So, I should add migration field for versioned_type myself

#47 - 2012-03-07 19:23 - John Yani

Here is a patch to enable wiki editing in Rails 3.2.1 https://github.com/marutosi/redmine/pull/6
#48 - 2012-03-10 15:03 - Jean-Philippe Lang

- Target version changed from Candidate for next major release to 2.0.0

#49 - 2012-03-10 16:41 - Terence Mill

Can u explain ur results? For the first look rails 2.3 and ruby 1.9.3 performns best, and not the newest stack with rails 3.

Jean-Philippe Lang wrote:

Here are the results of my quick performance tests (Rails 2.3 vs. Rails 3.2):

 

#50 - 2012-03-10 18:55 - Jean-Philippe Lang

Terence Mill wrote:

Can u explain ur results? For the first look rails 2.3 and ruby 1.9.3 performns best, and not the newest stack with rails 3.

 Indeed, Rails 2.3 performs best as mentionned above. The graph shows the average response times in seconds for a few actions (assets are not

involved here). Not much more to explain...

#51 - 2012-03-10 21:25 - John Yani

Terence Mill wrote:

Can u explain ur results? For the first look rails 2.3 and ruby 1.9.3 performns best, and not the newest stack with rails 3.

 Here is the detailed explanation:

http://bibwild.wordpress.com/2011/07/12/more-thoughts-on-unbearably-slow-rails3/

Shortly, it is because of extra ruby garbage collection, caused by increased size of the call stack in Rails 3.

#52 - 2012-04-15 06:45 - Alex Shulgin

Hello good sirs.

Any chance of getting this done finally, especially in light of this (rails 2.3 no longer receives security updates from the core team): 

https://groups.google.com/d/msg/rubyonrails-talk/ZzL90ec7iAQ/368GA-TeQ6AJ ?

--

Regards,

Alex

#53 - 2012-04-15 16:15 - Jean-Philippe Lang

The upgrade to Rails 3.0 is planned for Redmine 2.0 that should be the next major release.

#54 - 2012-04-17 00:59 - Terence Mill
Really waiting for this Release, especially Prototype.js has been replaced with jQuery for ajax calls.

#55 - 2012-04-17 01:52 - Toshi MARUYAMA

Terence Mill wrote:

Really waiting for this Release, especially Prototype.js has been replaced with jQuery for ajax calls.

 "prototype-rails" and "prototype_legacy_helper" provide compatibility.

#56 - 2012-04-17 08:45 - Etienne Massip

Terence Mill wrote:

Really waiting for this Release, especially Prototype.js has been replaced with jQuery for ajax calls.

 What difference does this make?

#57 - 2012-04-17 09:36 - Onno van der Straaten

Etienne Massip wrote:

Terence Mill wrote:

Really waiting for this Release, especially Prototype.js has been replaced with jQuery for ajax calls.

 What difference does this make?

 This is also one of the things I would like to see in Redmine 2.0. Upgrading to Rails 3 however does not imply that Redmine 2.0 will use JQuery. I

personally doubt that this effort is also about migrating to JQuery.

If you are using Redmine as is it doesn't matter what framework is being used. But if you want to extend Redmine, it does. So for example I added

functionality which uses a JQuery Slides (http://slidesjs.com/). Now my 'extended' Redmine installation uses JQuery and not Prototype for some

pages. Using Prototype and JQuery in one website is of course not so nice but necessary because JQuery has a lot more to offer.

#58 - 2012-04-17 10:00 - Etienne Massip

Onno van der Straaten wrote:

Using Prototype and JQuery in one website is of course not so nice but necessary because JQuery has a lot more to offer.

 Whatever, Redmine has not Javascript API, jQuery and Prototype can coexist very well and I can't see why using 2 tooling frameworks would be bad.

#59 - 2012-04-18 14:34 - Terence Mill

Hmm i hoped we will get rid of prototype because we wanna integrate our SSo Solution for redmine (which is based on CAS) and the problem with

redirect on ajax request direct after an revelidation attempt of the SSO gatway (a java servlet filter in front of web.xml war of a jruby redmine tomcat

installation), this redirect of an XMLHttpRequest (fired by prototyp.js i think) is not understood by the browser. This leads to "nothing happening" in the

application as long a non ajax request is triggered by the request caused by user click.

Our SSO Gateway in front of the redmine can understand jquery ajax requests and wraps them so that the redirect in the browser works. This does

not work for prototype js.

There is no documentation where and how often ajax is used in redmine forms, else we could think about moving this urls by filter out of the sso

secure area and workawound the problem.

Etienne Massip wrote:

Terence Mill wrote:

Really waiting for this Release, especially Prototype.js has been replaced with jQuery for ajax calls.

 What difference does this make?

#60 - 2012-04-18 15:15 - Etienne Massip

Terence Mill wrote:
Our SSO Gateway in front of the redmine can understand jquery ajax requests and wraps them so that the redirect in the browser works. This

does not work for prototype js.

 What is done with jQuery making the Ajax request understood that you can't do with Prototype?

#61 - 2012-05-01 18:16 - Jean-Philippe Lang

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- % Done changed from 70 to 100

- Resolution set to Fixed

Please open a new ticket for any issue related to Rails3 support.
